/*

Copyright (c) 2002 Hendrik Schreiber <hs@tagtraum.com>.

LGPL
====

This is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This software is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

For LGPL see <http://www.fsf.org/copyleft/lesser.txt>

For more information about this software see
<http://www.tagtraum.com/performance/>

*/
package com.tagtraum.perf.datastructures;

import java.util.*;
import java.io.*;

/**
 * Reads numbers from a file, sorts them and writes them to another file.
 * This implementation uses a boolean array for representation.
 *
 * @author <a href="mailto:hs@tagtraum.com">Hendrik Schreiber</a>
 * @version $Id: $
 */
public class TelephoneNumberSort3 {

   public static void main(String[] args) throws IOException {
      sort(args[0]);
      System.gc();
      sort(args[0]);
   }

   private static void sort(String filename) throws IOException {
      long start = System.currentTimeMillis();
      DataInputStream in = new DataInputStream(new BufferedInputStream(new FileInputStream(filename)));
      boolean[] array = new boolean[8999999];
      for (int i=0, b=(int) new File(filename).length()/4; i < b; i++) {
         array[in.readInt()-1000000] = true;
      }
      in.close();
      DataOutputStream out = new DataOutputStream(new BufferedOutputStream(new FileOutputStream(filename + ".sorted")));
      for (int i=0; i<array.length; i++) {
         if (array[i]) out.writeInt(i+1000000);
      }
      out.close();
      System.out.println(System.currentTimeMillis()-start + "ms");
   }

}
