/*

Copyright (c) 2002 Hendrik Schreiber <hs@tagtraum.com>.

LGPL
====

This is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This software is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

For LGPL see <http://www.fsf.org/copyleft/lesser.txt>

For more information about this software see
<http://www.tagtraum.com/performance/>

*/
package com.tagtraum.perf.ifsloopsandswitches;

/**
 * This class demonstrates the memory consumption by small, innocent looking anonymous inner classes.
 *
 * @author <a href="mailto:hs@tagtraum.com">Hendrik Schreiber</a>
 * @version $Id: $
 */
public class ActionClassMemoryConsumptionDemo {
   /**
    * Simple Action interface.
    */
   private static interface Action {
      /**
       * Do something.
       */
      public void action();
   }

   public static void main(String[] args) {
      long mem1;
      long mem2;
      long mem3;
      long mem4;
      long baseMem = Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory();
      Action a1 = new Action() {
         public void action() {
            action1();
         }
      };
      mem1 = Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory() - baseMem;
      baseMem = Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory();
      Action a2 = new Action() {
         public void action() {
            action1();
         }
      };
      mem2 = Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory() - baseMem;
      baseMem = Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory();
      Action a3 = new Action() {
         public void action() {
            action1();
         }
      };
      mem3 = Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory() - baseMem;
      baseMem = Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory();
      Action a4 = new Action() {
         public void action() {
            action1();
         }
      };
      mem4 = Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory() - baseMem;

      System.out.println("mem1: " + mem1);
      System.out.println("mem2: " + mem2);
      System.out.println("mem3: " + mem3);
      System.out.println("mem4: " + mem4);
   }

   public static void action1() {
   }
}
