/*

Copyright (c) 2002 Hendrik Schreiber <hs@tagtraum.com>.

LGPL
====

This is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This software is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

For LGPL see <http://www.fsf.org/copyleft/lesser.txt>

For more information about this software see
<http://www.tagtraum.com/performance/>

*/
package com.tagtraum.perf.io;

import java.io.IOException;

/**
 * Writes a text file with different CharWriterDemo classes.
 *
 * @author <a href="mailto:hs@tagtraum.com">Hendrik Schreiber</a>
 * @version $Id: $
 * @see CharWriterDemo1
 * @see CharWriterDemo2
 * @see CharWriterDemo3
 * @see CharWriterDemo4
 */
public class CharWriterDemo {
   public static void main(String[] args) throws IOException {
      String[] lines = getLines();

      int iterations = 40;
      long time;
      time = 0;
      System.out.println("CharWriterDemo1");
      for (int i = 0; i < iterations; i++) time += CharWriterDemo1.main(lines);
      System.out.println(time/iterations);
      time = 0;
      System.out.println("CharWriterDemo2");
      for (int i = 0; i < iterations; i++) time += CharWriterDemo2.main(lines);
      System.out.println(time/iterations);
      time = 0;
      System.out.println("CharWriterDemo3");
      for (int i = 0; i < iterations; i++) time += CharWriterDemo3.main(lines);
      System.out.println(time/iterations);
      time = 0;
      System.out.println("CharWriterDemo4");
      for (int i = 0; i < iterations; i++) time += CharWriterDemo4.main(lines);
      System.out.println(time/iterations);
   }

   static String[] getLines() {
      String[] lines = new String[1024 * 16];
      for (int i=0; i<lines.length; i++) {
         lines[i] = "abcdefghijklmnopqrstuvwxyz  abcdefghijklmnopqrstuvwxyz  abcdefghijklmnopqrstuvwxyz ";
      }
      return lines;
   }
}
