/*

Copyright (c) 2002 Hendrik Schreiber <hs@tagtraum.com>.

LGPL
====

This is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This software is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

For LGPL see <http://www.fsf.org/copyleft/lesser.txt>

For more information about this software see
<http://www.tagtraum.com/performance/>

*/
package com.tagtraum.perf.io;

import java.io.*;

/**
 * Copies a file with a buffered {@link FileReader} and {@link FileWriter}.
 * On top of {@link BufferedReader} and {@link BufferedWriter} a <code>char</code>
 * array is used.
 *
 * @author <a href="mailto:hs@tagtraum.com">Hendrik Schreiber</a>
 * @version $Id: $
 */
public class FileCopyDemo3 {
   public static long main(String[] args) throws IOException {
      long start = System.currentTimeMillis();
      Reader reader = new BufferedReader(new FileReader(args[0]));
      Writer writer = new BufferedWriter(new FileWriter(args[1]));
      int length;
      char[] cbuf = new char[1024 * 8];
      while ((length = reader.read(cbuf)) != -1) {
         writer.write(cbuf, 0, length);
      }
      reader.close();
      writer.close();
      return System.currentTimeMillis() - start;
   }
}
