/*

Copyright (c) 2002 Hendrik Schreiber <hs@tagtraum.com>.

LGPL
====

This is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This software is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

For LGPL see <http://www.fsf.org/copyleft/lesser.txt>

For more information about this software see
<http://www.tagtraum.com/performance/>

*/
package com.tagtraum.perf.io;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.channels.FileChannel;

/**
 * Copies a file using {@link FileChannel#transferFrom(ReadableByteChannel, long, long)}.
 *
 * @author <a href="mailto:hs@tagtraum.com">Hendrik Schreiber</a>
 * @version $Id: $
 */
public class FileCopyDemo7 {
   public static long main(String[] args) throws IOException {
      long start = System.currentTimeMillis();
      FileInputStream in = new FileInputStream(args[0]);
      FileOutputStream out = new FileOutputStream(args[1]);
      FileChannel inChannel = in.getChannel();
      FileChannel outChannel = out.getChannel();
      long position = 0;
      long transferred;
      long remaining = inChannel.size();
      while (remaining > 0) {
         transferred = outChannel.transferFrom(inChannel, position, remaining);
         position += transferred;
         remaining -= transferred;
      }
      in.close();
      out.close();
      return System.currentTimeMillis() - start;
   }
}
