/*

Copyright (c) 2002 Hendrik Schreiber <hs@tagtraum.com>.

LGPL
====

This is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This software is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

For LGPL see <http://www.fsf.org/copyleft/lesser.txt>

For more information about this software see
<http://www.tagtraum.com/performance/>

*/
package com.tagtraum.perf.memory;

/**
 * This class simply allocates some memory. It should be run
 * with the Sun Java VM option <code>-Xrunhprof</code> and
 * the resulting file java.hprof.txt should be inspected.<p>
 * On Linux systems you might need to set the flag <code>-classic</code> or
 * <code>-green -Djava.compiler=</code> to turn off HotSpot and use green
 * threads instead of native threads. It has been observed that native
 * threads on linux lead to somewhat strange results.
 *
 * @author <a href="mailto:hs@tagtraum.com">Hendrik Schreiber</a>
 * @version $Id: $
 */
public class HprofHeapDemo {

   private byte[] byteArray;
   private String string;
   private HprofHeapDemo internalDemoInstance;

   public void setByteArray() {
      byteArray = new byte[1024];
   }

   public void setString() {
      string = "1234567890"; // string with length 10
   }

   public void setHprofHeapDemo() {
      internalDemoInstance = new HprofHeapDemo();
   }

   public static void main(String[] args) {
      HprofHeapDemo demoInstance = new HprofHeapDemo();
      demoInstance.setByteArray();
      demoInstance.setString();
      demoInstance.setHprofHeapDemo();
   }
}
