/*

Copyright (c) 2002 Hendrik Schreiber <hs@tagtraum.com>.

LGPL
====

This is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This software is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

For LGPL see <http://www.fsf.org/copyleft/lesser.txt>

For more information about this software see
<http://www.tagtraum.com/performance/>

*/
package com.tagtraum.perf.strings;

/**
 * Logging <em>with</em> conditional String manipulation.
 *
 * @author <a href="mailto:hs@tagtraum.com">Hendrik Schreiber</a>
 * @version $Id: $
 */
public class ConditionalStringManipulationDemo2 {

    private int logLevel = 2;

    public static void main(String[] args) {
        ConditionalStringManipulationDemo2 demoInstance = new ConditionalStringManipulationDemo2();
        long start = System.currentTimeMillis();
        for (int i = 0; i < 1000000; i++) demoInstance.doIt();
        System.out.println(System.currentTimeMillis() - start);
    }

    public void doIt() {
        if (isLog(1)) log("Date: " + new java.util.Date());
    }

    public boolean isLog(int logLevel) {
        return logLevel > this.logLevel;
    }

    public void log(String message) {
        System.out.println(message);
    }
}
