/*

Copyright (c) 2002 Hendrik Schreiber <hs@tagtraum.com>.

LGPL
====

This is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This software is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

For LGPL see <http://www.fsf.org/copyleft/lesser.txt>

For more information about this software see
<http://www.tagtraum.com/performance/>

*/
package com.tagtraum.perf.threads;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Reader;
import java.net.URL;
import java.net.URLConnection;

/**
 * This is a NEGATIVE-EXAMPLE - how to NOT do it!
 *
 * @author <a href="mailto:hs@tagtraum.com">Hendrik Schreiber</a>
 * @version $Id: $
 * @see URLLoaderDemo2
 */
public class URLLoaderDemo1 extends Frame {

   private TextField urlField;
   private TextArea textArea;
   private Label statusBar;

   public static void main(String[] args) {
      new URLLoaderDemo1();
   }

   public URLLoaderDemo1() {
      super("URLLoaderDemo");
      Panel panel = new Panel();
      Button loadButton = new Button("Load");
      urlField = new TextField("Enter URL here", 30);
      textArea = new TextArea(20, 65);
      statusBar = new Label();
      final URLLoader urlLoader = new URLLoader();

      addWindowListener(new WindowAdapter() {
         public void windowClosing(WindowEvent e) {
            dispose();
         }
      });
      loadButton.addActionListener(urlLoader);
      urlField.addActionListener(urlLoader);

      panel.add(urlField, BorderLayout.NORTH);
      panel.add(loadButton, BorderLayout.NORTH);
      add(panel, BorderLayout.NORTH);
      add(textArea, BorderLayout.CENTER);
      add(statusBar, BorderLayout.SOUTH);

      setSize(300, 300);
      pack();
      setVisible(true);
   }


   private class URLLoader implements ActionListener {
      public void actionPerformed(ActionEvent e) {
         textArea.setText("");
         statusBar.setText("Loading " + urlField.getText());
         Reader in = null;
         try {
            in = new InputStreamReader(new URL(urlField.getText()).openStream());
            char[] cbuf = new char[1024 * 8];
            for (int count = 0; (count = in.read(cbuf)) != -1;) {
               textArea.append(new String(cbuf, 0, count));
               repaint();
            }
            statusBar.setText("Done.");
         } catch (IOException ioe) {
            statusBar.setText(ioe.toString());
         } finally {
            if (in != null)
               try {
                  in.close();
               } catch (IOException ioe) {
               }
         }
         repaint();
      }
   }
}
