/*

Copyright (c) 2002 Hendrik Schreiber <hs@tagtraum.com>.

LGPL
====

This is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This software is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

For LGPL see <http://www.fsf.org/copyleft/lesser.txt>

For more information about this software see
<http://www.tagtraum.com/performance/>

*/
package com.tagtraum.perf.strings;

import junit.framework.TestSuite;
import junit.framework.TestCase;

import java.util.Map;
import java.util.HashMap;
import java.util.Locale;
import java.text.Collator;

/**
 * @author <a href="mailto:hs@tagtraum.com">Hendrik Schreiber</a>
 * @version $Id: $
 */
public class TestCollationKeyMap extends TestCase {

    public TestCollationKeyMap(String name) {
        super(name);
    }

    public void testPutGet() throws Exception {
        Map map = new CollationKeyMap(Locale.GERMANY, Collator.SECONDARY);
        map.put("Hello", "Hello");
        assertNotNull("Failed to get item from map.", map.get("hellO"));
    }

    public void testPutGetPRIMARY() throws Exception {
        Map map = new CollationKeyMap(Locale.GERMANY, Collator.PRIMARY);
        map.put("bermig", "Hello");
        assertNotNull("Failed to get item from map.", map.get("ubermassig"));
    }

    public void testRemove() throws Exception {
        Map map = new CollationKeyMap(Locale.GERMANY, Collator.SECONDARY);
        map.put("Hello", "Hello");
        assertNotNull("Failed to get item from map.", map.remove("hellO"));
    }

    public void testContainsKey() throws Exception {
        Map map = new CollationKeyMap(Locale.GERMANY, Collator.SECONDARY);
        map.put("Hello", "Hello");
        assertTrue("Failed to get item from map.", map.containsKey("hellO"));
    }

    public static TestSuite suite() {
        return new TestSuite(TestCollationKeyMap.class);
    }

    public static void main(String[] args) {
        junit.textui.TestRunner.run(suite());
    }
}
